/*

	rexec.c

	KipTOOLS - (C) Angel Ortega

*/

#include <string.h>
#include "kiptools.h"


void exiterror(char * msg, int val)
{
	end_sockets();

	printf("%s: %s\n",msg, strerrorsocket());
	exit(val);
}


int buildcmd(char * buf, char * name, char * pass, char * cmd)
/* construye el comando REXEC sobre buf */
/* devuelve la longitud */
{
	*buf=0;
	buf++;

	strcpy(buf,name);
	buf+=strlen(name)+1;
	strcpy(buf,pass);
	buf+=strlen(pass)+1;
	strcpy(buf,cmd);

	return(4+strlen(name)+strlen(pass)+strlen(cmd));
}


int main(int argc, char * argv[])
{
	int s;
	struct hostent * h;
	struct sockaddr_in server;
	char str[4096];
	char cmd[300];
	int cmdlen;
	int l;

	/* logo */
	printf("\nREXEC (Remote Exec) - %s\n", KIPTOOLS_VERSION);
	printf("  (C) Angel Ortega 1995/1997\n\n");

	if(argc!=5)
	{
		printf("Usage: REXEC {host} {user} {password} {command}\n\n");
		exit(0);
	}

	if(!init_sockets())
		exiterror("init",2);

	/* transforma el IP */
	if((h=gethostbyname(argv[1]))==NULL)
	{
		printf("Error: host '%s' not found.\n", argv[1]);
		exiterror("gethostbyname",2);
	}

	memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);

	/* rellena la familia y el puerto destino */
	server.sin_family=AF_INET;
	server.sin_port=htons(512);

	/* pide un socket */
	if((s=socket(AF_INET, SOCK_STREAM, 0))==-1)
		exiterror("socket",3);

	if((connect(s,(struct sockaddr *)&server,sizeof(server)))==-1)
		exiterror("connect",4);

	/* construye el comando */
	cmdlen=buildcmd(cmd,argv[2],argv[3],argv[4]);

	/* lo enva */
	send(s,cmd,cmdlen,0);

	/* espera la respuesta */
	for(;;)
	{
		if((l=recv(s,str,sizeof(str)-1,0))==-1)
			break;

		str[l]=0;

		if(str[0]==1)
			printf("Rexec error: %s\n", &str[1]);
		else
			printf(&str[0]);
	}

	/* cierra el socket */
	if(closesocket(s)==-1)
		exiterror("close",7);

	end_sockets();

	return(0);
}
